YANG Data Model for Maximum SID Depth Types and MPLS Maximum SID Depth
Yingzhen Qu
Futurewei Technologies
yingzhen.ietf@gmail.com
Acee Lindem
LabN Consulting, L.L.C.
acee.ietf@gmail.com
Stephane Litkowski
Cisco Systems
slitkows.ietf@gmail.com
Jeff Tantsura
Nvidia
jefftant.ietf@gmail.com
General
MPLS Working Group
This document defines two YANG data modules. The first is the initial version of the IANA-maintained YANG module for Maximum Segment Identifier (SID) Depths (MSDs) Types, which includes identities for both the MPLS and SRv6 data planes. The second augments the IETF MPLS YANG model to provide support for MPLS MSDs as defined in RFC 8476 and RFC 8491.

Overview
There are two YANG modules defined in this document. Module iana-msd-types defines the identities for Maximum Segment Identifier (SID) Depth (MSD) Types as per the IANA IGP MSD-Types registry [IANA-IGP-MSD-Types], which include MSD types for both the MPLS data plane and the SRv6 data plane. This document also defines module ietf-mpls-msd augmenting the IETF MPLS YANG model [RFC8960], which itself augments the routing RIB data model [RFC8349], to provide operational state for various MSDs[RFC8662] for the MPLS data plane. The module augments the base MPLS model with a list of various types of node MSDs, as well as various types of MSDs on links.
The YANG modules in this document conform to the Network Management Datastore Architecture (NMDA) [RFC8342].

Design of the Model

IANA MSD Types Module
IANA has created an IANA-managed registry titled "IGP MSD-Types" under the "Interior Gateway Protocol (IGP) Parameters" registry to identify MSD-Types. Module iana-msd-types is an IANA-maintained module, which defines the identities for the MSD-Types as in the IANA IGP MSD-Types registry.
On top of the base identity "msd-base", identity "msd-base-mpls" is defined to serve as the base for MSD types for MPLS data plane, and identity "msd-base-srh" is defined to serve as the base for MSD types for Segment Routing Header (SRH) in IPv6 data plane.
This module will be maintained by IANA and updated if and when there is any change to the registry.

IETF MPLS MSD Module
Module ietf-mpls-msd augments the base MPLS model [RFC8960], and it provides support of different types of MSDs in MPLS data plane.
As defined in [RFC8491], a Link MSD is the number of SIDs supported by a node's link, while a Node MSD is the smallest MSD supported by the node across all its interfaces. The module defines lists of MSDs with different MSD Types for a node and links. Please note that these are read-only data as per the node's hardware capability.

Tree for IETF MPLS MSD Types YANG Module
This document uses the graphical representation of data models per [RFC8340].

module: ietf-mpls-msd

  augment /rt:routing/mpls:mpls:
    +--ro node-msds
       +--ro node-msd* [msd-type]
          +--ro msd-type     identityref
          +--ro msd-value?   uint8
  augment /rt:routing/mpls:mpls/mpls:interfaces/mpls:interface:
    +--ro link-msds
       +--ro link-msd* [msd-type]
          +--ro msd-type     identityref
          +--ro msd-value?   uint8

YANG Modules
There are two YANG modules defined in this document.

IANA-Maintained Module for MSD-Types
This document defines the initial version of the IANA-maintained YANG module for MSD Types, which mirrors the IANA IGP MSD-Types registry [IANA-IGP-MSD-Types].

<CODE BEGINS> file "iana-msd-types@2024-07-04.yang"
module iana-msd-types {
  yang-version 1.1;
  namespace "urn:ietf:params:xml:ns:yang:iana-msd-types";
  prefix iana-msd-types;

  organization
    "Internet Assigned Numbers Authority (IANA)";

  contact
    "Internet Assigned Numbers Authority

     ICANN
     12025 Waterfront Drive, Suite 300
     Los Angeles, CA 90094-2536
     United States of America

     Tel:    +1 310 301 5800
     <mailto:iana@iana.org>";

  description
    "The YANG module defines the identities for Maximum Segment
     Identifier (SID) Depth (MSD) Types.

     This YANG module is maintained by IANA and reflects the 'IGP
     MSD-Types' registry.

     Copyright (c) 2024 IETF Trust and the persons identified as
     authors of the code.  All rights reserved.

     Redistribution and use in source and binary forms, with or
     without modification, is permitted pursuant to, and subject to
     the license terms contained in, the Revised BSD License set
     forth in Section 4.c of the IETF Trust's Legal Provisions
     Relating to IETF Documents
     (https://trustee.ietf.org/license-info).

     This initial version of this YANG module is part of RFC XXXX
     (https://www.rfc-editor.org/info/rfcXXXX); see the RFC itself
     for full legal notices.

     //RFC Ed.: replace XXXX with actual RFC number and remove
       this note

     //RFC Ed.: replace IANA_FOO_URL and remove this note.

     The latest version of this YANG module is available at
     <IANA_FOO_URL>.";

  revision 2024-07-04 {
    description
      "Initial Version";
    reference
      "RFC XXXX: YANG Data Model for Maximum SID Depth Types and
                 MPLS Maximum SID Depth";
  }

  identity msd-base {
    description
      "Base identity for Maximum SID Depth (MSD) Type. The MSD type
       definition is defined in IANA IGP MSD-Types registry.";
  }

  identity msd-base-mpls {
    base msd-base;
    description
      "Base identity of MSD types for MPLS data plane.";
  }

  identity base-mpls-imposition-msd {
    base msd-base-mpls;
    description
      "Base MPLS Imposition MSD.";
    reference
      "RFC 8491: Signaling Maximum SID Depth (MSD) using IS-IS
       RFC 8476: Signaling Maximum SID Depth (MSD) using OSPF
       RFC 8664: Path Computation Element Communication Protocol
                 (PCEP) Extensions for Segment Routing
       RFC 8814: Signaling Maximum SID Depth (MSD) Using the Border
                 Gateway Protocol - Link State";
  }

  identity erld-msd {
    base msd-base-mpls;
    description
      "msd-erld is defined to advertise the Entropy Readable
       Label Depth (ERLD).";
    reference
      "RFC 8662: Entropy Label for Source Packet Routing in
                 Networking (SPRING) Tunnels
       RFC 9088: Signaling Entropy Label Capability and Entropy
                 Readable Label Depth Using IS-IS";
  }

  identity msd-base-srh {
    base msd-base;
    description
      "Base identity of MSD types for Segment Routing Header (SRH).";
  }

  identity srh-max-sl {
    base msd-base-srh;
    description
      "The Maximum Segment Left MSD type.";
    reference
      "RFC 9352: IS-IS Extensions to Support Segment Routing
                 over the IPv6 Data Plane";
  }

  identity srh-max-end-pop {
    base msd-base-srh;
    description
      "The Maximum End Pop MSD Type.";
    reference
      "RFC 9352: IS-IS Extensions to Support Segment Routing
                 over the IPv6 Data Plane";
  }

  identity srh-max-h-encaps {
    base msd-base-srh;
    description
      "The Maximum H.Encaps MSD Type.";
    reference
      "RFC 9352: IS-IS Extensions to Support Segment Routing
                 over the IPv6 Data Plane";
  }

  identity srh-max-end-d {
    base msd-base-srh;
    description
      "The Maximum End D MSD Type.";
    reference
      "RFC 9352: IS-IS Extensions to Support Segment Routing
                 over the IPv6 Data Plane";
  }
}
<CODE ENDS>

MPLS MSD YANG
This document also defines a YANG module for MSD extensions [RFC8476][RFC8491] to MPLS base model as defined in [RFC8960].

<CODE BEGINS> file "ietf-mpls-msd@2024-07-05.yang"
module ietf-mpls-msd {
  yang-version 1.1;
  namespace "urn:ietf:params:xml:ns:yang:ietf-mpls-msd";
  prefix mpls-msd;

  import ietf-routing {
    prefix rt;
    reference
      "RFC 8349: A YANG Data Model for Routing
                 Management (NMDA Version)";
  }
  import ietf-mpls {
    prefix mpls;
    reference
      "RFC 8960: A YANG Data Model for MPLS Base";
  }
  import iana-msd-types {
    prefix iana-msd-types;
  }

  organization
    "IETF Multiprotocol Label Switching (MPLS) Working Group";
  contact
    "WG Web:   <https://datatracker.ietf.org/wg/mpls/>
     WG List:  <mailto:mpls@ietf.org>

     Author:    Yingzhen Qu
               <mailto:yingzhen.ietf@gmail.com>
     Author:    Acee Lindem
               <mailto:acee.ietf@gmail.com>
     Author:    Stephane Litkowski
               <mailto:slitkows.ietf@gmail.com>
     Author:    Jeff Tantsura
               <mailto:jefftant.ietf@gmail.com>

    ";
  description
    "The YANG module augments the base MPLS model, and it is to
     provide support for different types of Maximum SID Depth (MSD).

     This YANG model conforms to the Network Management
     Datastore Architecture (NMDA) as described in RFC 8342.

     Copyright (c) 2024 IETF Trust and the persons identified as
     authors of the code.  All rights reserved.

     Redistribution and use in source and binary forms, with or
     without modification, is permitted pursuant to, and subject to
     the license terms contained in, the Revised BSD License set
     forth in Section 4.c of the IETF Trust's Legal Provisions
     Relating to IETF Documents
     (https://trustee.ietf.org/license-info).

     This version of this YANG module is part of RFC XXXX;
     see the RFC itself for full legal notices.";

  revision 2024-07-05 {
    description
      "Initial Version";
    reference
      "RFC XXXX: YANG Data Model for Maximum SID Depth Types and
                 MPLS Maximum SID Depth";
  }

  grouping msd-type-value {
    description
      "Grouping for MSD type and value.";
    leaf msd-type {
      type identityref {
        base iana-msd-types:msd-base-mpls;
      }
      description
        "MSD types. The MSD type is defined in IANA IGP
         MSD-Types registry.";
    }
    leaf msd-value {
      type uint8;
      description
        "MSD value, in the range of 0-255. 0 represents the lack
         of ability to support a SID stack of any depth.";
    }
  }
  augment "/rt:routing/mpls:mpls" {
    description
      "This module augments MPLS data model (RFC 8960)
       with node MSD.";
    container node-msds {
      config false;
      description
        "Maximum SID Depth (MSD) of a node.";
      list node-msd {
        key "msd-type";
        uses msd-type-value;
        description
          "List of different types of node MSDs. For the same
          type, the value of node MSD is the smallest among link MSD
          values.";
      }
    }
  }

  augment "/rt:routing/mpls:mpls/mpls:interfaces/mpls:interface" {
    description
      "This module augments MPLS data model (RFC 8960)
       with link MSD.";
    container link-msds {
      config false;
      description
        "Maximum SID Depth (MSD) of an interface.";
      list link-msd {
        key "msd-type";
        uses msd-type-value;
        description
          "List of different types of MSDs on the link.";
      }
    }
  }
}
<CODE ENDS>

Security Considerations
The YANG modules specified in this document define a schema for data that is designed to be accessed via network management protocols such as NETCONF [RFC6241] or RESTCONF [RFC8040]. These network management protocols are required to use a secure transport layer and mutual authentication, e.g., SSH [RFC6242] without the "none" authentication option, Transport Layer Security (TLS) [RFC8446] with mutual X.509 authentication, and HTTPS with HTTP authentication (Section 11 of [RFC9110]).
The NETCONF Access Control Model (NACM) [RFC8341] provides the means to restrict access for particular NETCONF or RESTCONF users to a pre-configured subset of all available NETCONF or RESTCONF protocol operations and content.
Some of the readable data nodes in the ietf-mpls-msd YANG module may be considered sensitive or vulnerable in some network environments. It is thus important to control read access (e.g., via get, get-config, or notification) to these data nodes. These are the subtrees and data nodes and their sensitivity/vulnerability:
/rt:routing/mpls:mpls/msd/node-msds
/rt:routing/mpls:mpls/msd/link-msds
Exposure of the node's maximum SID depth may be useful in mounting a Denial-of-Service (DoS) attack by sending packets to the node that the router can't process.
The iana-msd-types YANG module defines a set of identities, which mirrors the IANA IGP MSD-Types registry. These identities are intended to be reused by other YANG modules. The module by itself does not expose any data nodes that are writable or readable. As such, there are no additional security issues related to this YANG module that need to be considered.

IANA Considerations

Registering YANG Modules
This document registers URIs in the IETF XML registry [RFC3688]. Following the format in [RFC3688], the following registrations are requested to be made:

   URI: urn:ietf:params:xml:ns:yang:iana-msd-types
   Registrant Contact: The IESG.
   XML: N/A, the requested URI is an XML namespace.

   URI: urn:ietf:params:xml:ns:yang:ietf-mpls-msd
   Registrant Contact: The IESG.
   XML: N/A, the requested URI is an XML namespace.

This document registers the YANG modules in the YANG Module Names registry [RFC6020].

   name: iana-msd-types
   Maintained by IANA?  Y
   namespace: urn:ietf:params:xml:ns:yang:iana-msd-types
   prefix: iana-msd-types
   reference: RFC XXXX

   name: ietf-mpls-msd
   Maintained by IANA?  N
   namespace: urn:ietf:params:xml:ns:yang:ietf-mpls-msd
   prefix: mpls-msd
   reference: RFC XXXX

IANA MSD-Types Module
This document defines the initial version of the IANA-maintained "iana-msd-types" YANG module Section 4.1. The latest version of the YANG module is available from the "YANG Parameters" registry [IANA-YANG-Parameters].
IANA is requested to add this note to the "YANG Module Names" registry:
MSD Types must not be added directly to the iana-msd-types YANG module. They must first be added to [IANA-IGP-MSD-Types], which it mirrors.
The identities defined in the iana-msd-types YANG module are organized hierarchically based on the data plane. In this initial version, only MPLS and SRv6 data planes are supported, hence "msd-base-mpls" and "msd-base-srh" are defined. When a new data plane is added to the "IGP MSD-Types" registry, a new "identity" statement should be added to the "iana-msd-types" YANG module. The name of the "identity" is the prefix "msd-base-" plus a lower-case version of the data plane name . The identity statement should have the following sub-statements defined:
"base":
Contains 'msd-base'.
"description":
Replicates the description from "msd-base-mpls" and change the corresponding data plane name.
"reference":
Replicates the reference from the registry with the title of the document added.
When an MSD type is added to the "IGP MSD-Types" registry, a new "identity" statement must be added to the "iana-msd-types" YANG module. Then name of the "identity" is a lower-case version of the type name provided in the name with the space replaced with "-". The "identity" statement should have the following sub-statements defined:
"base":
Contains the base name of the corresponding data plane.
"description":
Replicates the name from the registry.
"reference":
Replicates the reference from the registry with the title of the document added.
Unassigned or reserved values are not present in the module.
When the "iana-msd-types" YANG module is updated, a new "revision" statement with a unique revision date must be added in front of the existing revision statements.
IANA is requested to the add a "data-plane" column to the "IGP MSD-Types" registry. This will unequivocally identify the base identity for MSD-Types. The values for the Data-Plane column for existing MSD-Types are:

Value      Name                      Data-Plane   Reference
0          Reserved                  N/A          [RFC8491]
1          Base MPLS Imposition MSD  MPLS         [RFC8491]
2          ERLD-MSD                  MPLS         [RFC9088]
3-40       Unassigned                N/A
41         SRH Max SL                SRv6         [RFC9352]
42         SRH Max End Pop           SRv6         [RFC9352]
43         Unassigned                N/A
44         SRH Max H.encaps          SRv6         [RFC9352]
45         SRH Max End               SRv6         [RFC9352]
46-250     Unassigned                N/A
251-254    Experimental Use          N/A          [RFC8491]
255        Reserved                  N/A          [RFC8491]

IANA is requested to add this note to [IANA-IGP-MSD-Types]:
When this registry is modified, the YANG module "iana-msd-types" must be updated as defined in RFC XXXX.

Acknowledgements
This document was produced using Marshall Rose's xml2rfc tool.
The YANG model was developed using the suite of YANG tools written and maintained by numerous authors.
We would like to thank Jan Lindblad, Tom Petch, Dhruv Dhody, Mohamed Boucadair and Susan Hares for their reviews and comments.

Normative References
[IANA-IGP-MSD-Types]

IGP MSD-Types
IANA
[IANA-YANG-Parameters]

YANG Module Names
IANA

Informative References
[RFC8960]
[RFC8349]
[RFC8662]
[RFC8342]
[RFC8491]
[RFC8340]
[RFC8476]
[RFC6241]
[RFC8040]
[RFC6242]
[RFC8446]
[RFC9110]
[RFC8341]
[RFC3688]
[RFC6020]